/*
 * Copyright (c) 2006-2007 Solexa
 * Author: Klaus Maisinger
 *
 * This source file is covered by the "Illumina Genome Analyzer
 * Software License Agreement" and bound by the terms therein.
 */

#ifndef BASECALLCONFIG_H_
#define BASECALLCONFIG_H_

namespace BaseCallConfig {
    const char  softwareName[]    = "Bustard";
    const char  softwareVersion[] = "1.9.6";
    const int   numBases          = 4;
    const float maxQScore         = 40.; // maximum quality score
    const int   numMCSamples      = 250; // number of Monte-Carlo samples
}

struct BasecallParameters {
    float PhasingRate;     // phasing rate
    float PrephasingRate;  // prephasing rate
    int   FirstCycle;      // first cycle to which the rates apply
    int   LastCycle;       // not used yet
    int   RestartFlag;     // not used yet
    BasecallParameters() : PhasingRate(0.), PrephasingRate(0.),
                           FirstCycle(0), LastCycle(-1), RestartFlag(1) {};
};

#endif /*BASECALLCONFIG_H_*/
