/*
 * Copyright (c) 2006-2007 Solexa
 * Author: Klaus Maisinger
 *
 * This source file is covered by the "Illumina Genome Analyzer
 * Software License Agreement" and bound by the terms therein.
 */

#ifndef BASECALLPARAMSXMLREADER_H_
#define BASECALLPARAMSXMLREADER_H_

#include "XMLContentHandler.h"
#include "BaseCallConfig.h"


class BaseCallParamsXMLReader : public XMLContentHandler
{
    int inParameters, inPhasing, inPrephasing;
    struct BasecallParameters params;
public:
    BaseCallParamsXMLReader();
    virtual ~BaseCallParamsXMLReader();
    virtual void startDocument();
    virtual void startElement(const char name[], const Attributes *attr = 0);
    virtual void endElement(const char name[]);
    virtual void characters(const char ch[], int start, int length);
    virtual void getParameters(struct BasecallParameters *params);
};

#endif /* BASECALLPARAMSXMLREADER_H_*/
