/*
 * Copyright (c) Illumina 2008
 * Author: Come Raczy
 * This source file is covered by the "Illumina Genome Analyzer
 * Software License Agreement" and bound by the terms therein.
 */

#ifndef CYCLE_MATRIX_CORRECTOR
#define CYCLE_MATRIX_CORRECTOR

#include "CycleMatrix.h"

class CycleMatrixCorrector : public CycleMatrix
{
public:
    CycleMatrixCorrector(const int numberOfChannels) : CycleMatrix(numberOfChannels) {}
    int estimate(const std::vector<float * > & cycleData,
                 const int                     numObjects,
                 const int                     numChannels);
    // scale the each matrix so that its norm is 1
    void scale(const unsigned int numChannels);
protected:
    float *estimate(const float *clusterIntensityList,
                    const unsigned int numObjects,
                    const unsigned int numChannels);
    void scale(float *matrix, const unsigned int numChannels);
};

#endif // #ifndef CYCLE_MATRIX_CORRECTOR
