#include <iostream>

using namespace std;

#include "testQhgOptions.hh"
#include "QhgFilter.hh"

CPPUNIT_TEST_SUITE_REGISTRATION( TestQhgOptions );

void TestQhgOptions::setUp()
{
    qhgOptions = new QhgOptions();
    char * const argv[] = {"quahog", "--filter", "purity", "--relation", "ge", "--threshold", "0.7"
        , "-p", "6"
        , "--compression", "gzip"
        , "--intensity-suffix", "_asdf.qqq"
        , "--quahog-suffix", "_qhg.txt"
        , "file1_asdf.qqq", "file2_asdf.qqq", "file3_asdf.qqq"
        , 0};
    int argc = 0;
    while (0 != argv[argc]) argc++;
    initError = qhgOptions->init(argc, argv); 
}

void TestQhgOptions::tearDown()
{
    delete qhgOptions;
    optind = 0;
}

void TestQhgOptions::testConstructor()
{
    CPPUNIT_ASSERT(qhgOptions != 0);
    // check the default values
    //CPPUNIT_ASSERT_EQUAL(qhgOptions->filter.compare("chastity"), 0);
    //CPPUNIT_ASSERT_EQUAL(qhgOptions->relation.compare("gt"), 0);
    //CPPUNIT_ASSERT_EQUAL(qhgOptions->threshold, (float)0.6);
    //CPPUNIT_ASSERT_EQUAL(qhgOptions->intensitySuffix.compare("_sig2.txt"), 0);
    CPPUNIT_ASSERT_EQUAL(qhgOptions->sequenceSuffix.compare("_seq.txt"), 0);
    CPPUNIT_ASSERT_EQUAL(qhgOptions->quahogSuffix.compare("_qhg.txt"), 0);
    CPPUNIT_ASSERT_EQUAL(qhgOptions->signalMeansSuffix.compare("_all.txt"), 0);
}

void TestQhgOptions::testInputList()
{
    CPPUNIT_ASSERT_EQUAL((unsigned long) qhgOptions->inputList.size(),
                         (unsigned long)3);
    CPPUNIT_ASSERT(!qhgOptions->inputList[0].compare("file1"));
    CPPUNIT_ASSERT(!qhgOptions->inputList[1].compare("file2"));
    CPPUNIT_ASSERT(!qhgOptions->inputList[2].compare("file3"));
}

void TestQhgOptions::testFilterOptions()
{
    CPPUNIT_ASSERT_EQUAL(qhgOptions->qhgFilter, &getQhgFilter("purity", "ge", 0.7)); 
}

void TestQhgOptions::testCompression()
{
    //CPPUNIT_ASSERT_EQUAL(qhgOptions->compression, IntensityData::compressionNone); 
    CPPUNIT_ASSERT_EQUAL(qhgOptions->compression, IntensityData::compressionGzip); 
}

void TestQhgOptions::testInit1()
{
    CPPUNIT_ASSERT_EQUAL( 0, initError);
}

void TestQhgOptions::testInit2()
{
    //CPPUNIT_ASSERT_EQUAL( 0, qhgOptions->init(7, cl03));
}

