#ifndef TEST_SEQUENCE_DATA
#define TEST_SEQUENCE_DATA

#include <cppunit/extensions/HelperMacros.h>

#include "IntensityData.h"
#include "SequenceData.h"

class TestSequenceData : public CppUnit::TestFixture
{
CPPUNIT_TEST_SUITE( TestSequenceData );
CPPUNIT_TEST( testConstructor );
//CPPUNIT_TEST( testInit1 );
//CPPUNIT_TEST( testInit2 );
//CPPUNIT_TEST( testFilterOptions );
//CPPUNIT_TEST( testCompression );
//CPPUNIT_TEST( testInputList );
CPPUNIT_TEST_SUITE_END();
private:
    int numCycles;
    int numClusters;
    int numChannels;
    PositionIndex *clusterPos;
    std::vector<float *> intensities;
    int readInputErrorCode;
    int readSequenceErrorCode;
    std::vector<unsigned char> *sequence_array;
public:
    void setUp();
    void tearDown();
    void testConstructor();
    //void testFilterOptions();
    //void testCompression();
    //void testInputList();
    //void testInit1();
    //void testInit2();
};

#endif // #ifndef TEST_SEQUENCE_DATA

