/*
 * Copyright (c) 2006 Solexa Ltd.
 * Author: Lorenzo Milazzo
 *
 * This source file is covered by the "Illumina Genome Analyzer
 * Software License Agreement" and bound by the terms therein.
 *
 */

#ifndef __ESTIMATE_XTALK_MX_H__
#define __ESTIMATE_XTALK_MX_H__

#include "savinio_common.h"

void applyXTalkMatrix(const float  * data,
                      const int      numData,
                      const int      numChannels,
                      const Matrix & matrix,
                      float        * dataNew);
void estimateXTalkMatrix(const float * data, 
                         const int     numData,
                         const int     numChannels,
                         Matrix      & matrixNormalised);
void filter_intensities(const float * input,
                        float       * output,
                        int           ncols, 
                        int           n_input,
                        int         * n_output);


#endif /* __ESTIMATE_XTALK_MX_H__ */
