/*
 * Copyright (c) Illumina 2008
 * Author:       Klaus Maisinger
 * This source file is covered by the "Illumina Genome Analyzer
 * Software License Agreement" and bound by the terms therein.
 */
#ifndef IMAGEANALYSISCONFIG_H
#define IMAGEANALYSISCONFIG_H

namespace ImageAnalysisConfig {
    const char softwareName[]    = "Firecrest";
    const char softwareVersion[] = "1.9.6";

    // The following two definitions help to allocate sensible array sizes
    // for internal scratch storage. If these numbers are too high, memory
    // is wasted. If they are too low, memory may have to be reallocated,
    // or clusters may get dropped.
    const int  numDefaultImagePixels = 2048; 
    const int  minPixelSpacePerObject = 15;
    const int  maxObjects = ((numDefaultImagePixels * numDefaultImagePixels)
                              / minPixelSpacePerObject);
    
    // minimum number of pixels an object must have
    const int  minObjectPixels = 3;
}

#endif /*IMAGEANALYSISCONFIG_H*/
