/*
 * Linear algebra subroutines.
 *
 * Copyright (c) Solexa 2005, 2006
 * Author:
 * Klaus Maisinger
 * This source file is covered by the "Illumina Genome Analyzer
 * Software License Agreement" and bound by the terms therein.
 */
#ifndef _LINALG_H_
#define _LINALG_H_

void matinvert(const float * matrix,
               float       * inverse,
               const int     n);
int cholesky_decompose(float *a, int n);
int lu_decompose_gauss_jordan_partial(float *a, int n, int *index);
int lu_decompose_gauss_jordan_partial(float *a, int n, int *index, float *d);
int lu_solve(float *a, int *index, int n, float *b, float *x, int n2 = 1);
int gauss_jordan_inverse_solve(float *a, int n, float *b, int n2);

void matrix_vectortranspose_multiply(float       * output,
                                     const float * matrix,
                                     const float * vector,
                                     const int     numRows,
                                     const int     numCols = 1);
void matrix_multiply(float       * output,
                     const float * matrix,
                     const float * input,
                     const int     numRows,
                     const int     numCols);

void print_matrix(float *a, int nx, int ny);
void print_imatrix(int *a, int nx, int ny);

#endif //_LINALG_H_
