/*
 * Copyright (c) Illumina 2007
 * Author:
 *               Klaus Maisinger
 * This source file is covered by the "Illumina Genome Analyzer
 * Software License Agreement" and bound by the terms therein.
 */
#ifndef INDEXPOSITION_H_
#define INDEXPOSITION_H_

#include "ParameterTypes.h"

struct PositionIndex
{
public:
    int lane;
    int tile;
    int X;
    int Y;
    PositionIndex(int                     lane,
                  int                     tile,
                  const struct Position & position);
    PositionIndex();
    PositionIndex(const PositionIndex & rhs);
    PositionIndex(const int iLane,
                  const int iTile,
                  const int iX,
                  const int iY);
    virtual ~PositionIndex();
    int snprint(char      buffer[],
                const int buffersize);
    static int write(const char       filename[],
                     const int        lane,
                     const int        tile,
                     const Position * positions,
                     const int        numClusters);
};

#endif /*INDEXPOSITION_H_*/
