/*
 * Copyright (c) 2006
 * Author: Klaus Maisinger
 * This source file is covered by the "Illumina Genome Analyzer
 * Software License Agreement" and bound by the terms therein.
 */
#ifndef STATS_H_
#define STATS_H_

namespace Stats {
    int linregress(float *x, float *y, int ndim,
                   float *gradient, float *intercept); 
    int round(const float f);

    template <class T>
    T average(const T *x,
              const int n);
    template <>
    float average<float>(const float *x,
                         const int n);
    template <class T>
    T min(const T *a,
          const int n);
    template <class T>
    T max(const T *a,
          const int n);
}

#endif /*STATS_H_*/
