/*   Time-stamp: <$Id: StringUtil.h,v 1.1 2008/07/02 08:38:24 craczy Exp $> */
/*
 * Copyright (c) Illumina 2007  
 * Author: Lukasz Szajkowski
 * This source file is covered by the "Illumina Genome Analyzer
 * Software License Agreement" and bound by the terms therein.
 */

#ifndef _STRING_UTIL_H
#define _STRING_UTIL_H

#include <string>
#include <vector>

using namespace std;


/*
 * Convert input string into vector of string tokens
 * strin string to be parsed
 * delims list of delimiters.
 */
std::vector<std::string> tokenize_str(const std::string & strin,
                                      const std::string & delims=", \t");
/*
 * The procedures tokenizes str string. seperate memory for each token is alocated.
 * Memory in tokenList should be dealocated
 */
void fastTokenizer(const char* str, char delim, vector<char*>& tokenList);

/*
 * The procedures tokenizes str string using str memory (the str str is changed)
 * The procedure is faster version of fastTokenizer
 */
void fastTokenizerInPlace(char* str, char delim, vector<char*>& tokenList);
	
/*
 * Replaces maching characters in the string with given new characters.
 * return number of characters replaced.
 */
int replaceTR(      std::string & strin,
              const std::string & findChars,
              const std::string & replCHars);

/*
 * Returns a ptr to a newly allocated C-string that is a copy of the supplied
 * string.
 */
char* copy_to_new_cstr(const std::string& str);

#endif /* _STRING_UTIL_H */
