#include <iostream>
#include <sstream>
#include <zlib.h>

using namespace std;

#include "RegistryName.hh"
#include "testAutoGzFile.hh"

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( TestAutoGzFile, registryName("AutoGzFile") );

void TestAutoGzFile::setUp()
{
    fileName = "testAutoGzFile.gz";
    s1 = "1";
    s2 = "2";
    s3 = "3";
    s4 = "4";
    gzFile fh = gzopen(fileName.c_str(), "w6R");
    gzputs(fh, s1.c_str());
    gzputs(fh, "\n");
    gzputs(fh, s2.c_str());
    gzputs(fh, "\n");
    gzputs(fh, s3.c_str());
    gzputs(fh, "\n");
    gzputs(fh, s4.c_str());
    gzputs(fh, "\n");
    gzclose(fh);
}

void TestAutoGzFile::tearDown()
{
}

void TestAutoGzFile::testConstructor()
{
    IoUtils::AutoGzFile fh(fileName.c_str(), "r");
    CPPUNIT_ASSERT (Z_NULL != fh);
}

void TestAutoGzFile::testRead()
{
    IoUtils::AutoGzFile fh(fileName, "r");
    CPPUNIT_ASSERT_EQUAL(s1, fh.getline());
    CPPUNIT_ASSERT_EQUAL(s2, fh.getline());
    CPPUNIT_ASSERT_EQUAL(s3, fh.getline());
    CPPUNIT_ASSERT_EQUAL(s4, fh.getline());
}
