#ifndef TEST_SEQUENCE_DATA
#define TEST_SEQUENCE_DATA

#include <cppunit/extensions/HelperMacros.h>

#include <string>

//#include "IntensityData.h"
//#include "SequenceData.h"

#include "../GzPack.hh"

class TestGzPack : public CppUnit::TestFixture
{
    CPPUNIT_TEST_SUITE( TestGzPack );
    CPPUNIT_TEST( testConstructor );
    CPPUNIT_TEST( testIntensityData );
    CPPUNIT_TEST( testEof );
    //CPPUNIT_TEST( testMissingChannel );
    //CPPUNIT_TEST( testExcessChannel );
    //CPPUNIT_TEST( testMissingCluster );
    //CPPUNIT_TEST( testInit1 );
    //CPPUNIT_TEST( testInit2 );
    //CPPUNIT_TEST( testFilterOptions );
    //CPPUNIT_TEST( testCompression );
    //CPPUNIT_TEST( testInputList );
    CPPUNIT_TEST_SUITE_END();
private:
    std::string fileName;
    
    unsigned int numberOfChannels;
    unsigned int numberOfClusters;
    unsigned int numberOfCycles;
    GzPack::GzPackReader *reader;
    void createFile();
    //std::string createMissingChannelFile();
    //std::string createExcessChannelFile();
    //std::string createMissingClusterFile();
public:
    void setUp();
    void tearDown();
    void testConstructor();
    void testIntensityData();
    void testEof();
    //void testMissingChannel();
    //void testExcessChannel();
    //void testMissingCluster();
    //void testFilterOptions();
    //void testCompression();
    //void testInputList();
    //void testInit1();
    //void testInit2();
};

#endif // #ifndef TEST_SEQUENCE_DATA

