/*
 * Copyright (c) 2007 Illumina
 * Author: Klaus Maisinger
 * This source file is covered by the "Illumina Genome Analyzer
 * Software License Agreement" and bound by the terms therein.
 */

#ifndef XMLIMAGECONFIGHANDLER_H_
#define XMLIMAGECONFIGHANDLER_H_

#include "XMLContentHandler.h"
#include "ParameterTypes.h"

class XMLImageConfigHandler : public XMLContentHandler
{
public:
    XMLImageConfigHandler(AnalysisParameters *_params);
    virtual ~XMLImageConfigHandler();
    virtual void startElement(const char name[], const Attributes *attr = 0);
    virtual void endElement(const char name[]);
    virtual void characters(const char ch[], int start, int length);
private:
    int inParameters;
    int inFwhm;
    int inThreshold;
    int inDistance;
    int inMinMatch;
    struct AnalysisParameters *params;
};

#endif /*XMLIMAGECONFIGHANDLER_H_*/
