get_filename_component(GA_CURRENT_DIR_NAME ${CMAKE_CURRENT_SOURCE_DIR} NAME)
message (STATUS "Adding the c++    library subdirectory: ${GA_CURRENT_DIR_NAME}")

##
## Some generators (VS) require all targets to be unique across the project.
## Therefore, a unique prefix is needed to create the target names which are
## shared across libraries
##

string(REGEX REPLACE ${CMAKE_SOURCE_DIR}/c[+][+]/ "" TMP1 ${CMAKE_CURRENT_SOURCE_DIR}/)
string(REGEX REPLACE "/" "_" GA_UNIQUE_PREFIX ${TMP1})

##
## build the library
##

file                (GLOB GA_LIBRARY_SOURCES *.cpp *.c)
set_source_files_properties(${GA_LIBRARY_SOURCES} PROPERTIES COMPILE_FLAGS ${GA_LIBRARY_COMPILE_FLAGS})
#include_directories (${CMAKE_CURRENT_SOURCE_DIR} ${GA_COMMON_INCLUDE})
include_directories (${GA_COMMON_INCLUDE})
add_library         (ga_${GA_LIB_DIR} ${GA_LIBRARY_SOURCES})

##
## build the unit tests if any (this should be mandatory really)
##

if (HAVE_CPPUNIT)
    find_path(${CMAKE_CURRENT_SOURCE_DIR}_CPPUNIT_DIR cppunit PATHS ${CMAKE_CURRENT_SOURCE_DIR} NO_DEFAULT_PATH)
    if (${CMAKE_CURRENT_SOURCE_DIR}_CPPUNIT_DIR)
        message (STATUS "Adding the cppunit subdirectory for ${GA_LIB_DIR}")
        add_subdirectory (cppunit)
    endif (${CMAKE_CURRENT_SOURCE_DIR}_CPPUNIT_DIR)
endif(HAVE_CPPUNIT)
