// -*- c++ -*-
/*****************************************************************************/
// Copyright (c) Illumina 2008
// Author: Richard Shaw
// This source file is covered by the Illumina Genome Analyzer Software 
// License Agreement and bound by the terms therein.
/*****************************************************************************/

#ifndef QAPPLY_OPTIONS_H
#define QAPPLY_OPTIONS_H

/*****************************************************************************/

#include <string>
#include <list>

#include "CommandLine.hh"
#include "File_Buffer.h"

/*****************************************************************************/

class QApply_Options : public CommandLine::Options
{
 public:
    QApply_Options();

    std::string my_orig_read_lengths_str;

    typedef std::list<unsigned int> Orig_Read_Lens_List;
    typedef Orig_Read_Lens_List::const_iterator Orig_Read_Lens_List_CIter;
    Orig_Read_Lens_List my_orig_read_lens_list;

    unsigned int my_read_num;
    unsigned int my_num_cycles;

    std::string my_qval_compr_name;
    File_Buffer::Compression_Type my_qval_compr;
    bool my_numeric_output_flag;
    std::string my_qtable_path_str;

    std::string my_tile_list_file_path_str;
    std::string my_tile_prefix_str;
    std::string my_qval_suffix_str;

    typedef std::list<std::string> Path_Str_List;
    typedef Path_Str_List::const_iterator Path_Str_List_CIter;
    Path_Str_List my_qval_path_str_list;


 private:
    virtual int getOptions(int argc, char* const argv[])
        throw (CommandLine::UnknownOptionException, 
               CommandLine::MissingOptionException, 
               CommandLine::InvalidArgumentException);
    virtual void processOptions()
        throw (CommandLine::InvalidArgumentException);
    virtual void getParameters(int argc, char* const argv[])
        throw (CommandLine::InvalidArgumentException);
    virtual int usage(int argc, char* const argv[],
                      const std::string &message = "");
};

/*****************************************************************************/

#endif // ! QAPPLY_OPTIONS_H

/*****************************************************************************/

