// -*- c++ -*-
/*****************************************************************************/
// Copyright (c) Illumina 2008
// Author: Richard Shaw
// This source file is covered by the Illumina Genome Analyzer Software 
// License Agreement and bound by the terms therein.
/*****************************************************************************/

#ifndef QCAL_OPTIONS_H
#define QCAL_OPTIONS_H

/*****************************************************************************/

#include <string>
#include <list>

#include "CommandLine.hh"
#include "File_Buffer.h"

/*****************************************************************************/

class QCal_Options : public CommandLine::Options
{
 public:
    QCal_Options();

    std::string my_qval_suffix_str;
    std::string my_qref_suffix_str;
    std::string my_qval_compr_name;
    std::string my_qref_compr_name;
    std::string my_cfg_path_str;

    File_Buffer::Compression_Type my_qval_compr;
    File_Buffer::Compression_Type my_qref_compr;

    std::string my_tile_list_file_path_str;
    std::string my_tile_prefix_str;

    typedef std::list<std::string> File_Name_List;
    typedef File_Name_List::const_iterator File_Name_List_CIter;
    File_Name_List my_qval_file_name_list;

 private:
    virtual int getOptions(int argc, char* const argv[])
        throw (CommandLine::UnknownOptionException, 
               CommandLine::MissingOptionException, 
               CommandLine::InvalidArgumentException);
    virtual void processOptions()
        throw (CommandLine::InvalidArgumentException);
    virtual void getParameters(int argc, char* const argv[])
        throw (CommandLine::InvalidArgumentException);
    virtual int usage(int argc, char* const argv[],
                      const std::string &message = "");
};

/*****************************************************************************/

#endif // ! QCAL_OPTIONS_H

/*****************************************************************************/
