// -*- mode: c++; indent-tabs-mode: nil; c-basic-offset: 4; -*-
//
// Copyright 2008 Illumina, Inc
// Author: Chris Saunders
//
// This source file is covered by the Illumina Genome Analyzer Software
// License Agreement and bound by the terms therein.
//

#ifndef QPREDICTORTYPES_H
#define QPREDICTORTYPES_H



namespace QPREDICTOR {

    // enum is constrained to start at 0 and end at SIZE:
    //
    enum index_t {
        IN_READ_CYCLE_NUM,
        SIGNAL_DECAY,
        UNBOUNDED_SIGNAL_DECAY,
        HOMOPOL_LEN,
        RAW_UNQUALITY,
        UNCHASTITY,
        UNPURITY,
        SHIFTED_UNCHASTITY,
        SHIFTED_UNPURITY,
        SHIFTED_SUM_DIFF_UNCHASTITY,
        GC_CONTENT,
        UNENTROPY,
        EDGINESS,
        MAX_EARLY_UNCHASTITY,
        MAX_EARLY_UNPURITY,
        MAX_EARLY_SHIFTED_UNCHASTITY,
        MAX_EARLY_SHIFTED_UNPURITY,
        MAX_EARLY_SHIFTED_SUM_DIFF_UNCHASTITY,
        MAX_LOCAL_UNCHASTITY,
        UNCHASTITY_NHOOD1,
        UNPURITY_NHOOD1,
        SHIFTED_UNCHASTITY_NHOOD1,
        SHIFTED_UNPURITY_NHOOD1,
        SHIFTED_SUM_DIFF_UNCHASTITY_NHOOD1,
        CONTEXT_5P1_3P1,
        CONTEXT_5P2_3P2,
        SIZE
    };

    const char*
    get_label(const index_t i);

    inline
    const char*
    get_label(const int i){ return get_label(static_cast<index_t>(i)); }

    /// returns SIZE if label does not match any QPREDICTOR types:
    index_t
    get_index(const char* label);
}


#endif
