// -*- c++ -*-
/*****************************************************************************/
// Copyright (c) Illumina 2008
// Author: Richard Shaw
// This source file is covered by the Illumina Genome Analyzer Software
// License Agreement and bound by the terms therein.
/*****************************************************************************/

#ifndef ADD_PAIRED_ELE_H
#define ADD_PAIRED_ELE_H

/*****************************************************************************/

template<class T, class U> class Add_Paired_Ele
{
public:
    Add_Paired_Ele(U iter) : my_iter(iter) { }
    ~Add_Paired_Ele() { }
    const T operator()(const T val) {
        const T ret_val(*my_iter + val);
        ++my_iter;
        return ret_val;
    }

private:
    U my_iter;
};

/*****************************************************************************/

#endif // ! ADD_PAIRED_ELE_H

/*****************************************************************************/
