/*****************************************************************************/
// Copyright (c) Illumina 2008
// Author: Richard Shaw
// This source file is covered by the Illumina Genome Analyzer Software
// License Agreement and bound by the terms therein.
/*****************************************************************************/

#include "Align_File_Data.h"
#include "Export_File_Data.h"
#include "Message.h"

#include "Align_Data_Factory.h"

/*****************************************************************************/

Align_Data_Factory::Align_Data_Factory()
{
    ;
}

/*****************************************************************************/

Align_Data* 
Align_Data_Factory::get_align_data(Input_Type input_type,
                                   const std::string& file_path_str,
                                   File_Buffer::Compression_Type compr_type)
    const
{
    Align_Data* align_data_ptr(0);

    switch (input_type) {

    case EXPORT_INPUT:
        align_data_ptr = new Export_File_Data(file_path_str, compr_type);
        break;

    case ALIGN_INPUT:
        align_data_ptr = new Align_File_Data(file_path_str, compr_type);
        break;
    }

    return align_data_ptr;
}

/*****************************************************************************/
