// -*- c++ -*-
/*****************************************************************************/
// Copyright (c) Illumina 2008
// Author: Richard Shaw
// This source file is covered by the Illumina Genome Analyzer Software
// License Agreement and bound by the terms therein.
/*****************************************************************************/

#ifndef ALIGN_DATA_FACTORY_H
#define ALIGN_DATA_FACTORY_H

/*****************************************************************************/

#include <string>

#include "Align_Data.h"
#include "File_Buffer.h"

/*****************************************************************************/

class Align_Data_Factory
{
 public:
    Align_Data_Factory();

    typedef enum { EXPORT_INPUT, ALIGN_INPUT } Input_Type;

    Align_Data* get_align_data(Input_Type input_type,
                               const std::string& file_path_str,
                               File_Buffer::Compression_Type compr_type) const;
};

/*****************************************************************************/

#endif // ! ALIGN_DATA_FACTORY_H

/*****************************************************************************/
