/*****************************************************************************/
// Copyright (c) Illumina 2008
// Author: Richard Shaw
// This source file is covered by the Illumina Genome Analyzer Software
// License Agreement and bound by the terms therein.
/*****************************************************************************/

#include "Base_Calls.h"

/*****************************************************************************/

void init_table(const std::string& str, std::valarray<unsigned int>& table)
{
    const unsigned int num_char_codes(2 << 8);
    table.resize(num_char_codes, 0);

    unsigned int code_val(0);

    for (std::string::const_iterator ch_citer(str.begin());
         ch_citer != str.end(); ++ch_citer) {
        table[*ch_citer] = code_val++;
    }
}

/*****************************************************************************/
