// -*- c++ -*-
/*****************************************************************************/
// Copyright (c) Illumina 2008
// Author: Richard Shaw
// This source file is covered by the Illumina Genome Analyzer Software
// License Agreement and bound by the terms therein.
/*****************************************************************************/

#ifndef BASIC_STATS_H
#define BASIC_STATS_H

/*****************************************************************************/

#include <vector>
#include <iostream>

#include "Base_Calls.h"

/*****************************************************************************/

class Basic_Stats {
    friend std::ostream& operator<<(std::ostream& ostrm, const Basic_Stats&);

 public:
    typedef Base_Calls<unsigned int> Uint_Base_Calls;

    Basic_Stats();
    ~Basic_Stats();
    bool derive(Uint_Base_Calls& base_calls);

 private:
    typedef std::vector<float> Cycle_Float_Vec;
    typedef Cycle_Float_Vec::iterator Cycle_Float_Vec_Iter;

    Cycle_Float_Vec my_pc_err_vec;
    Cycle_Float_Vec my_pc_blank_vec;
};

/*****************************************************************************/

std::ostream& operator<<(std::ostream& ostrm,
                         const Basic_Stats& basic_stats);

/*****************************************************************************/

#endif // ! BASIC_STATS_H

/*****************************************************************************/
