/*****************************************************************************/
// Copyright (c) Illumina 2008
// Author: Richard Shaw
// This source file is covered by the Illumina Genome Analyzer Software
// License Agreement and bound by the terms therein.
/*****************************************************************************/

#include "Cum_Errs.h"

/*****************************************************************************/

void Cum_Errs::set_num_cycles(const unsigned int num_cycles)
{
    my_num_cycles = num_cycles;
    my_cum_errs.resize(num_cycles * max_to_count);
}

/*****************************************************************************/

std::ostream& operator<<(std::ostream& ostrm, const Cum_Errs& cum_errs)
{
    ostrm << "Cycle:";

    for (unsigned int num_errs(1); num_errs <= cum_errs.max_to_count;
         ++num_errs) {
        ostrm << "\t" << num_errs;
    }

    ostrm << std::endl;


    unsigned int ele_ind(0);

    for (unsigned int cycle_num(1); cycle_num <= cum_errs.my_num_cycles;
         ++cycle_num) {
        ostrm << cum_errs.my_cycle_prefix_ch << cycle_num;

        for (unsigned int num_errs(1); num_errs <= cum_errs.max_to_count;
             ++num_errs) {
            ostrm << "\t" << cum_errs.my_cum_errs[ele_ind++];
        }

        ostrm << std::endl;
    }

    ostrm << std::endl;

    return ostrm;
}

/*****************************************************************************/
