// -*- c++ -*-
/*****************************************************************************/
// Copyright (c) Illumina 2008
// Author: Richard Shaw
// This source file is covered by the Illumina Genome Analyzer Software
// License Agreement and bound by the terms therein.
/*****************************************************************************/

#ifndef CUM_ERRS_H
#define CUM_ERRS_H

/*****************************************************************************/

#include <iostream>
#include <valarray>

/*****************************************************************************/

class Cum_Errs
{
    friend std::ostream& operator<<(std::ostream& ostrm, const Cum_Errs&);

public:
    Cum_Errs() { }
    ~Cum_Errs() { }

    enum { max_to_count = 5 };

    void set_num_cycles(const unsigned int num_cycles);
    std::valarray<unsigned int>& vals() { return my_cum_errs; }

    void set_cycle_prefix_ch(char cycle_prefix_ch) {
        my_cycle_prefix_ch = cycle_prefix_ch;
    }

private:
    std::valarray<unsigned int> my_cum_errs;
    unsigned int my_num_cycles;
    char my_cycle_prefix_ch;
};

/*****************************************************************************/

std::ostream& operator<<(std::ostream& ostrm, const Cum_Errs& cum_errs);

/*****************************************************************************/

#endif // ! CUM_ERRS_H

/*****************************************************************************/
