// -*- c++ -*-
/*****************************************************************************/
// Copyright (c) Illumina 2008
// Author: Richard Shaw
// This source file is covered by the Illumina Genome Analyzer Software
// License Agreement and bound by the terms therein.
/*****************************************************************************/

#ifndef EXPORT_FILE_DATA_H
#define EXPORT_FILE_DATA_H

/*****************************************************************************/

#include "Align_Data.h"
#include "ExportFileReader.h" // Initially just for the field indices.
#include "File_Buffer.h"

/*****************************************************************************/

class Export_File_Data : public Align_Data
{
public:
    Export_File_Data(const std::string& data_file_name,
                     const File_Buffer::Compression_Type compression 
                     = File_Buffer::compressionNone);
    virtual ~Export_File_Data();

    virtual bool get_next_read_align_info(Read_Align_Info& read_align_info,
                                          bool& at_eof);

    virtual char blank_base();

private:
    // values from ExportFileReader.h
    enum { LANE_NUM_FIELD_IND = Lane,
           TILE_NUM_FIELD_IND = Tile,
           READ_NUM_FIELD_IND = ReadNumber,
           READ_SEQ_FIELD_IND = Read,
           ALIGN_POS_FIELD_IND = MatchPosition,
           STRAND_DIR_FIELD_IND = MatchStrand,
           MISMATCH_FIELD_IND = MatchDescriptor,
           ALIGN_SCORE_FIELD_IND = SingleReadAlignmentScore,
           PASSED_FILTER_FIELD_IND = Filtering
    };
};

/*****************************************************************************/

#endif // ! EXPORT_FILE_DATA_H

/*****************************************************************************/
