// -*- c++ -*-
/*****************************************************************************/
// Copyright (c) Illumina 2008
// Author: Richard Shaw
// This source file is covered by the Illumina Genome Analyzer Software
// License Agreement and bound by the terms therein.
/*****************************************************************************/

#ifndef INCREMENTAL_ACCUM_H
#define INCREMENTAL_ACCUM_H

/*****************************************************************************/

template <class T> class Incremental_Accum
{
 public:
    Incremental_Accum(T initial_sum = 0)
        : my_sum(initial_sum) { }
    ~Incremental_Accum() { }

    const T operator()(const T val) {
        return (my_sum += val);
    }

 private:
    T my_sum;
};

/*****************************************************************************/

#endif // ! INCREMENTAL_ACCUM_H

/*****************************************************************************/
