/*****************************************************************************/
// Copyright (c) Illumina 2008
// Author: Richard Shaw
// This source file is covered by the Illumina Genome Analyzer Software
// License Agreement and bound by the terms therein.
/*****************************************************************************/

#include <cmath>

#include "Likelihood_Calc.h"

/*****************************************************************************/

const float Likelihood_Calc::our_to_base10_factor = 1.0 / log(10.0);
const int Likelihood_Calc::our_neutral_score 
= int(100.0 * our_to_base10_factor * log(1.0 / (4.0 - 1.0)));

/*****************************************************************************/

Likelihood_Calc::Likelihood_Calc(float sum)
    : my_sum(sum)
{ 
    ;
}

/*****************************************************************************/

int Likelihood_Calc::operator()(const unsigned int val)
{
    return (((my_sum != val) && (val != 0))
            ? int(100 * our_to_base10_factor * log(val / (my_sum - val)))
            : our_neutral_score);
}

/*****************************************************************************/
