// -*- c++ -*-
/*****************************************************************************/
// Copyright (c) Illumina 2008
// Author: Richard Shaw
// This source file is covered by the Illumina Genome Analyzer Software
// License Agreement and bound by the terms therein.
/*****************************************************************************/

#ifndef NON_BLANK_FILTER_H
#define NON_BLANK_FILTER_H

/*****************************************************************************/

#include <cassert>
#include <valarray>

/*****************************************************************************/

const char the_blank_ch('N');

/*****************************************************************************/

class Non_Blank_Filter
{
public:
    Non_Blank_Filter(std::valarray<unsigned int>& non_blank_mask)
        : my_non_blank_mask(non_blank_mask), my_ele_ind(0) { }
    ~Non_Blank_Filter() { }

    void operator()(const char ch) {
        // assert(ch != '.');
        my_non_blank_mask[my_ele_ind++] = ((ch != the_blank_ch) ? 1 : 0);
    }

private:
    std::valarray<unsigned int>& my_non_blank_mask;
    size_t my_ele_ind;
};

/*****************************************************************************/

#endif // ! NON_BLANK_FILTER_H

/*****************************************************************************/
