// -*- c++ -*-
/*****************************************************************************/
// Copyright (c) Illumina 2008
// Author: Richard Shaw
// This source file is covered by the Illumina Genome Analyzer Software
// License Agreement and bound by the terms therein.
/*****************************************************************************/

#ifndef PAS_OPTIONS_H
#define PAS_OPTIONS_H

/*****************************************************************************/

#include <string>
#include <list>

#include "Align_Data_Factory.h"
#include "CommandLine.hh"
#include "File_Buffer.h"

/*****************************************************************************/

class PAS_Options : public CommandLine::Options
{
 public:
    PAS_Options();
    ~PAS_Options();
    
    Align_Data_Factory::Input_Type my_input_type;

    std::string my_input_compr_name;
    File_Buffer::Compression_Type my_input_compr;

    typedef std::list<std::string> Path_Str_List;
    typedef Path_Str_List::const_iterator Path_Str_List_CIter;
    Path_Str_List my_input_path_str_list;

    std::string my_speced_score_path_str;
    std::string my_tile_list_file_path_str;

 private:
    virtual int getOptions(int argc, char* const argv[])
        throw (CommandLine::UnknownOptionException, 
               CommandLine::MissingOptionException, 
               CommandLine::InvalidArgumentException);
    virtual void processOptions()
        throw (CommandLine::InvalidArgumentException);
    virtual void getParameters(int argc, char* const argv[])
        throw (CommandLine::InvalidArgumentException);
    virtual int usage(int argc, char* const argv[],
                      const std::string& message = "");
};

/*****************************************************************************/

#endif // ! PAS_OPTIONS_H

/*****************************************************************************/
