/*
 * Time-stamp: <$Id: QrawData.cpp,v 1.2 2008/07/03 11:36:01 craczy Exp $>
 * 
 * Copyright (c) 2007      Illumina
 * Author:       Lukasz Szajkowski
 *
 * This source file is covered by the "Solexa Public Source License"
 * agreement and bound by the terms therein.
 */

#include <string>
#include <vector>
#include "QrawData.h"
#include "Message.h"
#include "IOProcess.h"

QrawData::QrawData(const char filename []) {
    _Filename = filename;
}

QrawData::~QrawData() {
}

int QrawData::write(const std::vector<int *> & probabilities,
        const int numClusters, const int numChannels, const int isNumeric) {
    std::string convertedString;
    serialize(probabilities, numClusters, isNumeric, convertedString);
    return append_file(_Filename.c_str(), convertedString.c_str(),
            convertedString.length());
    
}

int QrawData::write(const std::string &convertedString) {
    return append_file(_Filename.c_str(), convertedString.c_str(),
            convertedString.length());    
}

void QrawData::serialize(const std::vector<int *> & probabilities,
        const unsigned int numClusters, const int isNumeric,
        std::string & convertedString) {
    unsigned int clusterIndex;
    unsigned int cycleIndex;
    unsigned int numCycles = probabilities.size();
    char convertedValueStr[256];
    for (clusterIndex = 0; clusterIndex < numClusters; clusterIndex++) {
        for (cycleIndex = 0; cycleIndex < numCycles; cycleIndex++) {
            int * qualityQraw = probabilities[cycleIndex];
            if (isNumeric == 0) {
                sprintf(convertedValueStr, "%c",
                        (char)(qualityQraw[clusterIndex]));
                convertedString.append(convertedValueStr);
            } else {
                // Refactor
                sprintf(convertedValueStr, " %d", qualityQraw[clusterIndex]
                        - 64);
                convertedString.append(convertedValueStr);
            }
        }
        // Remove white spaces from left
        while (convertedString.size()> 0 && (*convertedString.begin()) == ' ') {
            convertedString.erase(convertedString.begin());
        }
        convertedString.append("\n");
    }
}
