// -*- c++ -*-
/*****************************************************************************/
// Copyright (c) Illumina 2008
// Author: Richard Shaw
// This source file is covered by the Illumina Genome Analyzer Software
// License Agreement and bound by the terms therein.
/*****************************************************************************/

#ifndef READ_ALIGN_INFO
#define READ_ALIGN_INFO

/*****************************************************************************/

#include <string>

/*****************************************************************************/

class Read_Align_Info {
public:
    Read_Align_Info();

    bool is_aligned() const { return my_aligned_flag; }
    bool passed_filter() const { return my_passed_filter_flag; }

    unsigned int my_lane_num;
    unsigned int my_tile_num;
    unsigned int my_read_num;
    bool my_passed_filter_flag;

    std::string my_read_str;
    std::string my_ref_str;

    bool my_aligned_flag;
    unsigned int my_align_score;
};

/*****************************************************************************/

#endif // ! READ_ALIGN_INFO

/*****************************************************************************/
