// -*- c++ -*-
/*****************************************************************************/
// Copyright (c) Illumina 2008
// Author: Richard Shaw
// This source file is covered by the Illumina Genome Analyzer Software
// License Agreement and bound by the terms therein.
/*****************************************************************************/
//
// Definitions and functions for test harnesses of classes derived from
// CommandLine::Options.
//
/*****************************************************************************/

#ifndef OPTION_TEST_UTILS_H
#define OPTION_TEST_UTILS_H

/*****************************************************************************/

#include <string>
#include <map>
#include <list>

typedef std::map<std::string, std::string> Opt_Arg_Map;
typedef Opt_Arg_Map::iterator Opt_Arg_Map_Iter;
typedef Opt_Arg_Map::const_iterator Opt_Arg_Map_CIter;

typedef std::list<std::string> Arg_List;
typedef Arg_List::iterator Arg_List_Iter;
typedef Arg_List::const_iterator Arg_List_CIter;

/*****************************************************************************/

bool check_opt_arg_match(Opt_Arg_Map& opt_arg_map,
                         const std::string& opt_name,
                         const std::string& found_str);

/*****************************************************************************/

#endif // ! OPTION_TEST_UTILS_H

/*****************************************************************************/
