#!/bin/bash

. ./bootstrap/common.sh
common_variables
SCRIPT=cmake.sh
SOURCE_TGZ=${OPT_DIR}/cmake-2.6.0.tar.gz
SOURCE_DIR=${OPT_DIR}/cmake-2.6.0
CMAKE_DIR=cmake-2.6
VERSION="cmake version 2.6-patch 0"

common_options $@

if [[ $CLEAN ]] ; then
    echo removing $SOURCE_DIR
    rm -rf $SOURCE_DIR
    rm -rf ${OPT_DIR}/{doc,share}/$CMAKE_DIR
    rm -f ${OPT_DIR}/bin/{ccmake,cmake,cpack,ctest}
    rm -f ${OPT_DIR}/man/man1/{ccmake,cmake,cmakecommands,cmakecompat,cmakemodules,cmakeprops,cmakevars,cpack,ctest}.1
    exit 0
fi

if [[ `cmake --version 2> /dev/null` == "$VERSION" && ! $FORCE ]] ; then
    echo cmake version \"$VERSION\" is already installed
    echo nothing to be done
    exit 0
fi 

common_create_source

cd $SOURCE_DIR && ./bootstrap --prefix=.. && make -j 2 && make install

if [ $? != 0 ] ; then echo "cmake: build failed: Terminating..." >&2 ; exit 1 ; fi

echo "Ckeaning up ${SOURCE_DIR}"
rm -rf ${SOURCE_DIR}

echo CMake installed successfully

