
function common_variables () {
    OPT_DIR=`pwd`
    if [[ ! -d $OPT_DIR ]] ; then
        echo Could not find $OPT_DIR. 
        echo Make sure that the script is started fron the \'opt\' directory.
        Terminating...
        exit 1
    fi
    BIN_DIR=${OPT_DIR}/bin
    LIB_DIR=${OPT_DIR}/lib
    INCLUDE_DIR=${OPT_DIR}/include
}

function common_options () {
    TEMP=`getopt -n $SCRIPT -o fc -- "$@"`
    if [ $? != 0 ] ; then echo $SCRIPT: invalid option ; echo "Terminating..." >&2 ; exit 1 ; fi
    eval set -- "$TEMP"
    FORCE=
    CLEAN=
    while true ; do
        case "$1" in
            -f) FORCE=true ; shift ;;
            -c) CLEAN=true ; shift ;;
            --)              shift ; break ;;
            *) echo "Internal error!" ; exit 1 ;;
        esac
    done
}

function common_create_source () {
    if [[ ! -e $SOURCE_TGZ ]] ; then
        echo $SCRIPT: source tarball not found
        exit 1
    fi  
    echo Decompressing $SOURCE_TGZ
    tar -C ${OPT_DIR} -zxf $SOURCE_TGZ
    
    if [[ ! -d $SOURCE_DIR ]] ; then
        echo $SOURCE_DIR does not exist
        exit 1
    fi
}

