
get_filename_component(GA_CURRENT_DIR_NAME ${CMAKE_CURRENT_SOURCE_DIR} NAME)
message (STATUS "Adding the perl   program subdirectory: ${GA_CURRENT_DIR_NAME}")

file (GLOB GA_SCRIPT_LIST *.pl)
foreach(GA_SCRIPT_SOURCE ${GA_SCRIPT_LIST})
    get_filename_component(GA_SCRIPT ${GA_SCRIPT_SOURCE} NAME)
    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${GA_SCRIPT}
      COMMAND sed "'s|^my $$GA_DATA_DIR *= *.*$$|my $$GA_DATA_DIR = \"${GA_DATA_DIR}\";|'" ${GA_SCRIPT_SOURCE} |
              sed "'s|^my $$GA_BIN_DIR *= *.*$$|my $$GA_BIN_DIR = \"${GA_BIN_DIR}\";|'" |
              sed "'s|^use lib \"$$FindBin::Bin/.*$$|use lib \"${GA_PERL_LIB_DIR}\";|'" > ${GA_SCRIPT}
      DEPENDS ${GA_SCRIPT_SOURCE}
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      COMMENT "Building ${GA_SCRIPT}: ${TMP}")
    install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/${GA_SCRIPT} DESTINATION bin)
endforeach(GA_SCRIPT_SOURCE)

string(REPLACE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} ALL_PERL_PROGRAMS "${GA_SCRIPT_LIST}")
string(REPLACE ${CMAKE_SOURCE_DIR} "" PERL_TARGET ${CMAKE_CURRENT_SOURCE_DIR})
string(REGEX REPLACE ^[/\\] "" PERL_TARGET ${PERL_TARGET})
string(REGEX REPLACE [/\\] "_" PERL_TARGET ${PERL_TARGET})
add_custom_target(${PERL_TARGET} ALL DEPENDS ${ALL_PERL_PROGRAMS})
