#!/usr/bin/env perl


## This program takes the individual IVC plots and combines them
## into a single htm page which links to orginal files
## The page format has been designed by Tony Cox

# Copyright (c) 2006 Solexa
# This source file is covered by the "Solexa Public Source License"
# agreement and bound by the terms therein.

### The program is called using directory name

use warnings;
use strict;

use FindBin;
use lib "$FindBin::Bin/../lib";
use Gerald::Common;

my $version;
my $id;
{
    my $cvs_id='@(#) $Id: create_IVC_monotemplates_thumbnail.pl,v 1.2 2008/07/08 15:12:10 craczy Exp $';
    my $cvs_version='$Revision: 1.2 $';
    # Make CVS tag into a displayable string
    $version=$cvs_version;
    $version=~s/\$//g;
    $version=~s/Revision//;
    $id=$cvs_id;
#    $id=~s/\$//g;
} #scope


my ($file,$i,$j,$output_name,$expt_name,$k,$seq,$directory);
my (%lane,%tile,%results,%template,%use_lanes);


if(@ARGV < 2){
    print STDERR "create_IVC_monotemplates_thumbnail.pl Expt_dir Lanes\n";
    die;
}

$directory = shift(@ARGV);

for($i=0;$i<@ARGV;$i++){
    $use_lanes{$ARGV[$i]} = 1;
}


## Look for experimental number
$expt_name=getRunFolderName($directory);
if (! defined($expt_name)) {
    warn "Could not parse experiment name from ${directory}";
    $expt_name = "";
}

## Define output file name

#$output_name = $expt_name."_IVC_thumb.htm";
#$Output_name = $directory."/".$expt_name."_IVC_thumb.htm";

#open(,">$output_name") || die "Can't open $output_name\n";
print  q(<!--RUN_TIME. scalar(localtime)-->);
print  q(<!--SOFTWARE_VERSION $id-->);


print  qq(<html><head>);

print  qq(<title>$expt_name Monotemplate IVC</title>);

  print  qq(<h1 align = "center"><a name="Top">$expt_name IVC By Template</h1></a>);


## Starting the html output with the body name


opendir (DIR,$directory) or die "can't open $directory\n";


while (defined($file = readdir (DIR))){
    next if ($file !~ m/s_[0-9]_[A-Z]+_all\.png$/);
    next if ($file =~ m/[%]/);

    my @array = split('_',$file);
    if(exists $use_lanes{$array[1]}){
 
    
    $results{$file} = $array[1];
 #   print "$array[1]\n";
    $template{$array[2]}++;
}
}

print qq(<h3>Template List<br><h3>);

foreach $seq (sort keys %template){
    print  qq(<a href="#$seq">$seq<br></a>);
#    print qq(<h3>$seq</h3>);
}

print "<br><br><br>";

foreach $seq (sort keys %template){
   print  qq(<h2><a name="$seq">$seq</h2></a>);
   

print  qq(<table border="1" cellpadding="5"><tr><td><b>Lane</b></td>);
print  qq(<td><b>All</b></td>);
print  qq(<td><b>Called</b></td>);
print  qq(<td><b>% Errors</b></td>);
print  qq(<td><b>% Perfect</b></td>);

print  qq(</tr>);

    foreach $j (sort keys %results){
	next if ($j !~ m/$seq/);

	
	print  qq(<tr><td><b>$results{$j}</b></td>);
    
	if(defined $results{$j}){
	    $file = $j;
	    print  qq(<td><a href="Plots/$file"> <img height=168 width=150 src="Plots/$file"></a></td>);
	}
	else {
	    print  qq(<td>&nbsp;</td>);
	}
	$file = $j;
	$file =~ s/_all.png/_call.png/;
	if(defined $file){
	    print  qq(<td><a href="Plots/$file"> <img height=168 width=150 src="Plots/$file"></a></td>);
	}
	else {
	    print  qq(<td>&nbsp;</td>);
	}
    	$file = $j;
	$file =~ s/_all.png/_error.png/;

	if(defined $file){
	    print  qq(<td><a href="Plots/$file"> <img height=168 width=150 src="Plots/$file"></a></td>);
	}
	else {
	    print  qq(<td>&nbsp;</td>);
	}
	$file = $j;
	$file =~ s/_all.png/_perfect.png/;

	if(defined $file){
	    print  qq(<td><a href="Plots/$file"> <img height=168 width=150 src="Plots/$file"></a></td>);
	}
	else {
	    print  qq(<td>&nbsp;</td>);
	}

    
    print  qq(</tr>);

 
    }
    
    print qq(</table>);
 print  "<td><br><br><a href=\"#Top\">Back to top</a></td><br><br>";

}

