#!/usr/bin/env python
#
# Copyright (c)  2007 Illumina
# Authors:       Klaus Maisinger
# This source file is covered by the "Solexa Public Source License"
# agreement and bound by the terms therein.

"""Convert a Fwhm XML to a Firecrest configuration XML file."""

import sys, os, os.path
GA_LIB_LIST=[os.path.join(os.path.dirname(os.path.realpath(sys.argv[0])), "..", "lib")]
sys.path = GA_LIB_LIST + sys.path
import XMLSimple, common, goat_pipeline

inputKey   = 'fwhm'
outputKeys = [ 'Fwhm', 'RemappingDistance' ]
outputRoot = 'ImageParameters'

def usage():
    print "%s <XML file>"


if __name__ == "__main__":
    if len(sys.argv) != 2:
        usage()
        sys.exit(1)
    filename = sys.argv[1]
    try:
        data = XMLSimple.XMLin(filename)
    except:
        common.error("Could not read %s." % filename)
        sys.exit(1)

    params = goat_pipeline.ImageParams()
    if data.has_key(inputKey):
        size = float(data[inputKey])
        params.setSize(size)
        print params.getParamsXML(),
    else:
        common.error("XML file %s mising key: %s." %
                     (filename, inputKey))
        sys.exit(1)
